//
//	MMXgp\`FbN
//
//		Copyright (c) 2000-2005 Chihiro.SAKAMOTO (HyperWorks)
//
#include "StdAfx.h"
#include "MMX.h"

bool CheckMMXTechnology()
{
	int	cpuid_support;

	//
	// CPUID߂T|[gĂ邩
	//
	_asm	{
		pushfd
		pop eax
		xor eax,00200000h
		push eax
		popfd
		pushfd
		pop ebx
		cmp eax,ebx
		mov cpuid_support,1
		je L1
		mov cpuid_support,0
L1:
	} ;
	//
	// CPUIDT|[gĂȂȂ΁AMMX߂T|[gĂȂ
	//
	if (!cpuid_support)
		return false;

	//
	// CPUID߂gMMX߂̗L𔻒肷
	//
	int		hv;
	_asm	{
		xor	eax,eax
		cpuid
		mov	hv,eax
	} ;
	if (hv < 1)
		return false;

	int		featureFlags;
	_asm	{
		mov	eax,1
		cpuid
		mov	featureFlags,edx
	} ;
	if (featureFlags & 0x00800000)
		return true;
	return false;
}

const bool MmxSupported = CheckMMXTechnology();
